"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.asyncCallResultHandler = void 0;
exports.default = (asyncWithClassicalCallback, context) => {
    return (...args) => __awaiter(void 0, void 0, void 0, function* () {
        return new Promise((resolve, reject) => {
            asyncWithClassicalCallback.call(context, ...args, (err, result) => {
                if (!err) {
                    resolve(result);
                }
                else {
                    reject(err);
                }
            });
        });
    });
};
function asyncCallResultHandler(asyncWithResultCallback, context) {
    return (question) => __awaiter(this, void 0, void 0, function* () {
        return new Promise((resolve, reject) => {
            asyncWithResultCallback.call(context, question, (res) => {
                resolve(res);
                context.close();
            });
        });
    });
}
exports.asyncCallResultHandler = asyncCallResultHandler;
