"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs_1 = __importDefault(require("fs"));
const grpc = __importStar(require("grpc"));
const path_1 = __importDefault(require("path"));
const ramda_1 = __importDefault(require("ramda"));
const getPackageDefinition_1 = __importDefault(require("./getPackageDefinition"));
const deprecated_1 = __importDefault(require("./helpers/deprecated"));
const rpc_error_hinter_1 = __importDefault(require("./helpers/rpc-error-hinter"));
const terminal_node_1 = require("./helpers/terminal-node");
/**
 * @deprecated, will be deleted in the future
 * @param endpoint
 * @param protoPath
 * @param packageName
 * @param service
 */
function createClientService(endpoint, protoPath, packageName, service) {
    const packageDefinition = (0, getPackageDefinition_1.default)(protoPath);
    const parts = packageName.split('.');
    if (packageDefinition[parts[0]]) {
        const pack = packageDefinition[parts[0]][parts[1]];
        if (pack) {
            return new pack[service](endpoint, grpc.credentials.createInsecure());
        }
    }
    return null;
}
class Client {
    constructor(endpoint, protoPath = ramda_1.default.head(ramda_1.default.filter(fs_1.default.existsSync, ramda_1.default.map(p => path_1.default.resolve(__dirname, p), [
        '../node_modules/grpc-health/src/health/health.proto',
        '../../grpc-health/src/health/health.proto',
    ])))) {
        if (!protoPath) {
            throw new Error('Parameter protoPath must be provided!');
        }
        if (!fs_1.default.existsSync(protoPath)) {
            throw new Error(`File ${protoPath} does not exists!`);
        }
        this.endpoint = endpoint;
        // tslint:disable-next-line
        this.packDef = getPackageDefinition_1.default.call(this, protoPath);
        this.grpc = (0, getPackageDefinition_1.default)(protoPath);
        this.promisifyAllGrpcMethods();
    }
    /**
     * @deprecated, use new(endpoint, protoPath) instead
     * @param endpoint
     * @param protoPath
     * @param packageName
     * @param service
     */
    static connect(endpoint, protoPath, packageName, service) {
        // tslint:disable-next-line
        return createClientService(endpoint, protoPath, packageName, service);
    }
    promisifyAllGrpcMethods() {
        (0, terminal_node_1.traverseServiceClients)(this.grpc, (ServiceClient, key, parent) => {
            parent[key] = new ServiceClient(this.endpoint, grpc.credentials.createInsecure());
            for (const method in parent[key]) {
                if (typeof parent[key][method] === 'function' &&
                    [
                        'makeUnaryRequest',
                        'makeClientStreamRequest',
                        'makeServerStreamRequest',
                        'makeBidiStreamRequest',
                        'close',
                        'getChannel',
                        'waitForReady',
                        'resolveCallInterceptors',
                    ].indexOf(method) < 0) {
                    const original = parent[key][method];
                    this.promisifyMethod(parent, key, method, original);
                }
            }
        });
    }
    promisifyMethod(parent, key, method, original) {
        parent[key][method] = (arg, metaData) => {
            return new Promise((resolve, reject) => {
                this.callOriginal(original, parent, key, arg, method, reject, resolve, metaData);
            });
        };
    }
    // tslint:disable-next-line: parameters-max-number
    callOriginal(original, parent, key, arg, method, reject, resolve, metaData = {}) {
        original.call(parent[key], arg, metaData, this.promiseCallback(method, reject, resolve));
    }
    promiseCallback(method, reject, resolve) {
        return (err, res) => {
            if (err) {
                rpc_error_hinter_1.default.hint(method, err, this.endpoint);
                reject(err);
            }
            else {
                resolve(res);
            }
        };
    }
    /**
     * @deprecated, use grpc's instead
     * @param service
     */
    getService(service) {
        const parts = service.split('.');
        // tslint:disable-next-line
        let s = this.packDef[parts[0]];
        for (let i = 1; i < parts.length; i++) {
            s = s[parts[i]];
        }
        return new s(this.endpoint, grpc.credentials.createInsecure());
    }
}
__decorate([
    (0, deprecated_1.default)("use grpc's method instead")
], Client.prototype, "getService", null);
__decorate([
    (0, deprecated_1.default)('use new() instead')
], Client, "connect", null);
exports.default = Client;
