"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function deprecated(message = 'Function {name} is deprecated.') {
    return (instance, name, descriptor) => {
        const original = descriptor.value;
        const localMessage = message.replace('{name}', name);
        descriptor.value = function () {
            console.warn(localMessage);
            return original.apply(this, arguments);
        };
        return descriptor;
    };
}
exports.default = deprecated;
