"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.traverseServiceClients = void 0;
function traverseServiceClients(obj, traverseAction, maxDepth = 100) {
    if (maxDepth <= 0) {
        throw new Error('层级太深了！');
    }
    Object.keys(obj).forEach(value => {
        if (typeof obj[value] === 'object' && (!obj[value].format || (obj[value].format !== 'Protocol Buffer 3 DescriptorProto'))) {
            traverseServiceClients(obj[value], traverseAction, maxDepth - 1);
        }
        else if (typeof obj[value] === 'function' && obj[value].toString().startsWith('function ServiceClient')) {
            traverseAction(obj[value], value, obj);
        }
    });
}
exports.traverseServiceClients = traverseServiceClients;
function getTerminalNodes(obj) {
    const res = [];
    traverseServiceClients(obj, v => res.push(v));
    return res;
}
exports.default = getTerminalNodes;
