#! /usr/bin/env node
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.client = void 0;
const health_helper_1 = __importDefault(require("grpc-health/dist/health/health.helper"));
const readline_1 = __importDefault(require("readline"));
const AsyncCall_1 = require("./AsyncCall");
const Client_1 = __importDefault(require("./Client"));
const Greeter_1 = require("./Greeter");
const composer_1 = __importDefault(require("./helpers/composer"));
const [exe, exeFilePath, endpoint, protoFilePath = health_helper_1.default.getHealthCheckProtoPath()] = process.argv;
(0, Greeter_1.Greeter)(exe, exeFilePath, endpoint, protoFilePath);
exports.client = new Client_1.default(endpoint, protoFilePath);
if (exports.client === null) {
    console.error(`Failed to connect to ${endpoint} or find proto ${protoFilePath}`);
    process.exit(1);
}
if (require.main === module) {
    process.nextTick(() => __awaiter(void 0, void 0, void 0, function* () {
        const rl = readline_1.default.createInterface({
            input: process.stdin,
            output: process.stdout,
        });
        const input = yield (0, AsyncCall_1.asyncCallResultHandler)(rl.question, rl)(`Input method name and parameters, for example: package.Service.get {"arg1": "value1"}
Enter with empty input will do health check: grpc.health.v1.Health.check {} 
>>>: `);
        const parts = input.split(' ');
        const args = parts[1] ? JSON.parse(parts[1]) : {};
        const methodString = parts[0] || 'grpc.health.v1.Health.check';
        console.log('will call method: ', methodString, ' with args: ', args);
        const method = composer_1.default.composeMethod(exports.client.grpc, methodString);
        const res = yield method(args);
        console.log(res);
    }));
}
exports.default = Client_1.default;
